// v0    - Vertex Position
// v7   - Vertex Texture Data u,v 
// c0   - time vector
// c4-7 - Composite World-View-Projection Matrix
vs.1.1

dcl_position0 v0
dcl_texcoord0 v7

m4x4 oPos, v0, c4        //transformed position

frc r0.xy, c0.x          //tex coords + time (1st set)
add  oT0.xy, v7,  r0
add  oT1.xy, v7, -r0

mov r0.x, -c0.y          //tex coords + time (2nd set)
mov r0.y, c0.y
frc r0.xy, r0
add  oT2.xy, v7,  r0
add  oT3.xy, v7, -r0

mov oT4, v7              //original tex coord