vs.1.1 

dcl_position0 v0   // v0 = position
dcl_normal0   v1   // v1 = normal

// The following constants are set externally
// c4 ...c7  = world matrix, current frame
// c8 ...c11 = rotation matrix (from Arcball)
// c12...c15 = view matrix
// c16...c19 = projection matrix
// c20.z     = 1

//-------------------------------------------------------------------------
// POSITION
//-------------------------------------------------------------------------

m4x4 r1, v0, c4 
m4x4 r2, r1, c8 
m4x4 r3, r2, c12 
m4x4 oPos, r3, c16 

//-------------------------------------------------------------------------
// DIFFUSE
//-------------------------------------------------------------------------

m3x3 r0.xyz, v1, c4 
m3x3 r1.xyz, r0, c8 
m3x3 r2.xyz, r1, c12 
mov oD0.xyz, -r2.z 
mov oD0.w, c20.z 
// oD0.xyz = DIFFUSE color, assuming fixed light direction (0, 0, -1)
// oD0.w   = 1.0f = alpha (opaque)